diff -r -u squid-2.6.STABLE13/src/icp_v3.c new-STABLE13/src/icp_v3.c
--- squid-2.6.STABLE13/src/icp_v3.c	Wed May 18 01:56:38 2005
+++ new-STABLE13/src/icp_v3.c	Sun May 13 00:59:37 2007
@@ -37,7 +37,7 @@
 
 /* Currently Harvest cached-2.x uses ICP_VERSION_3 */
 void
-icpHandleIcpV3(int fd, struct sockaddr_in from, char *buf, int len)
+icpHandleIcpV3(int fd, struct sockaddr *from, char *buf, int len)
 {
     icp_common_t header;
     icp_common_t *reply;
@@ -69,31 +69,32 @@
 	if (strpbrk(url, w_space)) {
 	    url = rfc1738_escape(url);
 	    reply = icpCreateMessage(ICP_ERR, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_INVALID, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_INVALID, 0);
 	    break;
 	}
 	if ((icp_request = urlParse(METHOD_GET, url)) == NULL) {
 	    reply = icpCreateMessage(ICP_ERR, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_INVALID, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_INVALID, 0);
 	    break;
 	}
 	memset(&checklist, '\0', sizeof(checklist));
-	checklist.src_addr = from.sin_addr;
-	checklist.my_addr = no_addr;
+	xmemcpy(&checklist.src_addr, from, SOCKLEN(from));
+	memset(&checklist.my_addr, '\0', sizeof(checklist.my_addr));
+	checklist.my_addr.ss_family = from->sa_family;
 	checklist.request = icp_request;
 	allow = aclCheckFast(Config.accessList.icp, &checklist);
 	if (!allow) {
 	    debug(12, 2) ("icpHandleIcpV3: Access Denied for %s by %s.\n",
-		inet_ntoa(from.sin_addr), AclMatchedName);
-	    if (clientdbCutoffDenied(from.sin_addr)) {
+		sockaddr_ntoa(from), AclMatchedName);
+	    if (clientdbCutoffDenied(from)) {
 		/*
 		 * count this DENIED query in the clientdb, even though
 		 * we're not sending an ICP reply...
 		 */
-		clientdbUpdate(from.sin_addr, LOG_UDP_DENIED, PROTO_ICP, 0);
+		clientdbUpdate(from, LOG_UDP_DENIED, PROTO_ICP, 0);
 	    } else {
 		reply = icpCreateMessage(ICP_DENIED, 0, url, header.reqnum, 0);
-		icpUdpSend(fd, &from, reply, LOG_UDP_DENIED, 0);
+		icpUdpSend(fd, from, reply, LOG_UDP_DENIED, 0);
 	    }
 	    break;
 	}
@@ -103,19 +104,19 @@
 	    icp_opcode_str[header.opcode]);
 	if (icpCheckUdpHit(entry, icp_request)) {
 	    reply = icpCreateMessage(ICP_HIT, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_HIT, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_HIT, 0);
 	    break;
 	}
 	/* if store is rebuilding, return a UDP_HIT, but not a MISS */
 	if (opt_reload_hit_only && store_dirs_rebuilding) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else if (hit_only_mode_until > squid_curtime) {
 	    reply = icpCreateMessage(ICP_MISS_NOFETCH, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS_NOFETCH, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_MISS_NOFETCH, 0);
 	} else {
 	    reply = icpCreateMessage(ICP_MISS, 0, url, header.reqnum, 0);
-	    icpUdpSend(fd, &from, reply, LOG_UDP_MISS, 0);
+	    icpUdpSend(fd, from, reply, LOG_UDP_MISS, 0);
 	}
 	break;
 
@@ -129,18 +130,18 @@
     case ICP_MISS_NOFETCH:
 	if (neighbors_do_private_keys && header.reqnum == 0) {
 	    debug(12, 0) ("icpHandleIcpV3: Neighbor %s returned reqnum = 0\n",
-		inet_ntoa(from.sin_addr));
+		sockaddr_ntoa(from));
 	    debug(12, 0) ("icpHandleIcpV3: Disabling use of private keys\n");
 	    neighbors_do_private_keys = 0;
 	}
 	url = buf + sizeof(icp_common_t);
 	debug(12, 3) ("icpHandleIcpV3: %s from %s for '%s'\n",
 	    icp_opcode_str[header.opcode],
-	    inet_ntoa(from.sin_addr),
+	    sockaddr_ntoa(from),
 	    url);
 	key = icpGetCacheKey(url, (int) header.reqnum);
 	/* call neighborsUdpAck even if ping_status != PING_WAITING */
-	neighborsUdpAck(key, &header, &from);
+	neighborsUdpAck(key, &header, from);
 	break;
 
     case ICP_INVALID:
@@ -149,7 +150,7 @@
 
     default:
 	debug(12, 0) ("icpHandleIcpV3: UNKNOWN OPCODE: %d from %s\n",
-	    header.opcode, inet_ntoa(from.sin_addr));
+	    header.opcode, sockaddr_ntoa(from));
 	break;
     }
     if (icp_request)
diff -r -u squid-2.6.STABLE13/src/ident.c new-STABLE13/src/ident.c
--- squid-2.6.STABLE13/src/ident.c	Sat May 13 07:08:37 2006
+++ new-STABLE13/src/ident.c	Sun May 13 00:59:37 2007
@@ -48,9 +48,10 @@
 
 typedef struct _IdentStateData {
     hash_link hash;		/* must be first */
+    int ia_cur;			/* dummy, for commConnectStart */
     int fd;			/* IDENT fd */
-    struct sockaddr_in me;
-    struct sockaddr_in my_peer;
+    struct sockaddr_storage me;
+    struct sockaddr_storage my_peer;
     IdentClient *clients;
 } IdentStateData;
 
@@ -94,7 +95,7 @@
 {
     IdentStateData *state = data;
     debug(30, 3) ("identTimeout: FD %d, %s\n", fd,
-	inet_ntoa(state->my_peer.sin_addr));
+	sockaddr_ntoa(&state->my_peer));
     comm_close(fd);
 }
 
@@ -123,8 +124,12 @@
     }
     memBufDefInit(&mb);
     memBufPrintf(&mb, "%d, %d\r\n",
-	ntohs(state->my_peer.sin_port),
-	ntohs(state->me.sin_port));
+	(state->my_peer.ss_family == AF_INET6) ?
+	ntohs(((struct sockaddr_in6 *)&state->my_peer)->sin6_port):
+	ntohs(((struct sockaddr_in *)&state->my_peer)->sin_port),
+	(state->my_peer.ss_family == AF_INET6) ?
+	ntohs(((struct sockaddr_in6 *)&state->me)->sin6_port):
+	ntohs(((struct sockaddr_in *)&state->me)->sin_port) );
     comm_write_mbuf(fd, mb, NULL, state);
     commSetSelect(fd, COMM_SELECT_READ, identReadReply, state, 0);
     commSetTimeout(fd, Config.Timeout.ident, identTimeout, state);
@@ -187,19 +192,18 @@
  * start a TCP connection to the peer host on port 113
  */
 void
-identStart(struct sockaddr_in *me, struct sockaddr_in *my_peer, IDCB * callback, void *data)
+identStart(struct sockaddr *me, struct sockaddr *my_peer, IDCB * callback, void *data)
 {
     IdentStateData *state;
     int fd;
     char key1[IDENT_KEY_SZ];
     char key2[IDENT_KEY_SZ];
     char key[IDENT_KEY_SZ];
-    snprintf(key1, IDENT_KEY_SZ, "%s:%d",
-	inet_ntoa(me->sin_addr),
-	ntohs(me->sin_port));
-    snprintf(key2, IDENT_KEY_SZ, "%s:%d",
-	inet_ntoa(my_peer->sin_addr),
-	ntohs(my_peer->sin_port));
+    char ahost[100], aport[8];
+    getnameinfo(me, SOCKLEN(me), ahost, 100, aport, 8, NI_NUMERICHOST|NI_NUMERICSERV);
+    snprintf(key1, IDENT_KEY_SZ, "%s:%s", ahost, aport);
+    getnameinfo(my_peer, SOCKLEN(my_peer), ahost, 100, aport, 8, NI_NUMERICHOST|NI_NUMERICSERV);
+    snprintf(key2, IDENT_KEY_SZ, "%s:%s", ahost, aport);
     snprintf(key, IDENT_KEY_SZ, "%s,%s", key1, key2);
     if ((state = hash_lookup(ident_hash, key)) != NULL) {
 	identClientAdd(state, callback, data);
@@ -207,8 +211,7 @@
     }
     fd = comm_open(SOCK_STREAM,
 	IPPROTO_TCP,
-	me->sin_addr,
-	0,
+	me,
 	COMM_NONBLOCKING,
 	"ident");
     if (fd == COMM_ERROR) {
@@ -220,8 +223,8 @@
     state = cbdataAlloc(IdentStateData);
     state->hash.key = xstrdup(key);
     state->fd = fd;
-    state->me = *me;
-    state->my_peer = *my_peer;
+    xmemcpy(&state->me, me, SOCKLEN(me));
+    xmemcpy(&state->my_peer, my_peer, SOCKLEN(my_peer));
     identClientAdd(state, callback, data);
     hash_join(ident_hash, &state->hash);
     comm_add_close_handler(fd,
@@ -229,8 +232,7 @@
 	state);
     commSetTimeout(fd, Config.Timeout.ident, identTimeout, state);
     commConnectStart(fd,
-	inet_ntoa(state->my_peer.sin_addr),
-	IDENT_PORT,
+	sockaddr_ntoa(my_peer), IDENT_PORT,
 	identConnectDone,
 	state);
 }
diff -r -u squid-2.6.STABLE13/src/internal.c new-STABLE13/src/internal.c
--- squid-2.6.STABLE13/src/internal.c	Fri Aug 25 21:26:07 2006
+++ new-STABLE13/src/internal.c	Sun May 13 00:59:37 2007
@@ -46,7 +46,7 @@
     const char *upath = strBuf(request->urlpath);
     http_version_t version;
     debug(76, 3) ("internalStart: %s requesting '%s'\n",
-	inet_ntoa(request->client_addr), upath);
+	sockaddr_ntoa(&request->client_addr), upath);
     if (0 == strcmp(upath, "/squid-internal-dynamic/netdb")) {
 	netdbBinaryExchange(entry);
     } else if (0 == strcmp(upath, "/squid-internal-periodic/store_digest")) {
@@ -99,10 +99,17 @@
     /* convert host name to lower case */
     xstrncpy(lc_host, host, SQUIDHOSTNAMELEN);
     Tolower(lc_host);
+
+    /*
+     * host is IPv6 address
+     */
+    if (strchr(lc_host, ':'))
+	snprintf(lc_host, SQUIDHOSTNAMELEN, "[%s]", host);
     /*
      * append the domain in order to mirror the requests with appended
      * domains
      */
+    else
     if (Config.appendDomain && !strchr(lc_host, '.'))
 	strncat(lc_host, Config.appendDomain, SQUIDHOSTNAMELEN -
 	    strlen(lc_host) - 1);
diff -r -u squid-2.6.STABLE13/src/ipc.c new-STABLE13/src/ipc.c
--- squid-2.6.STABLE13/src/ipc.c	Sat Sep  9 04:41:24 2006
+++ new-STABLE13/src/ipc.c	Sun May 13 00:59:37 2007
@@ -87,30 +87,32 @@
     if (hIpc)
 	*hIpc = NULL;
 
+    CS.sin_family = AF_INET;
+#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
+    CS.sin_len = sizeof(CS);
+#endif
+    CS.sin_addr = local_addr;
+    CS.sin_port = 0;
     if (type == IPC_TCP_SOCKET) {
 	crfd = cwfd = comm_open(SOCK_STREAM,
 	    IPPROTO_TCP,
-	    local_addr,
-	    0,
+	    &CS,
 	    COMM_NOCLOEXEC,
 	    name);
 	prfd = pwfd = comm_open(SOCK_STREAM,
 	    IPPROTO_TCP,	/* protocol */
-	    local_addr,
-	    0,			/* port */
+	    &CS,
 	    0,			/* blocking */
 	    name);
     } else if (type == IPC_UDP_SOCKET) {
 	crfd = cwfd = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    local_addr,
-	    0,
+	    &CS,
 	    COMM_NOCLOEXEC,
 	    name);
 	prfd = pwfd = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    local_addr,
-	    0,
+	    &CS,
 	    0,
 	    name);
     } else if (type == IPC_FIFO) {
diff -r -u squid-2.6.STABLE13/src/ipcache.c new-STABLE13/src/ipcache.c
--- squid-2.6.STABLE13/src/ipcache.c	Wed Aug 16 09:27:20 2006
+++ new-STABLE13/src/ipcache.c	Sun May 13 00:59:37 2007
@@ -112,7 +112,7 @@
 static void
 ipcacheRelease(ipcache_entry * i)
 {
-    debug(14, 3) ("ipcacheRelease: Releasing entry for '%s'\n", (const char *) i->hash.key);
+    debug(14, 3) ("ipcacheRelease: Releasing entry %x for '%s'\n", i, (const char *) i->hash.key);
     hash_remove_link(ip_table, (hash_link *) i);
     dlinkDelete(&i->lru, &lru_list);
     ipcacheFreeEntry(i);
@@ -285,7 +285,7 @@
     if (ipcount <= 0) {
 	debug(14, 1) ("ipcacheParse: No addresses in response to '%s'\n", name);
     } else {
-	i->addrs.in_addrs = xcalloc(ipcount, sizeof(struct in_addr));
+	i->addrs.in_addrs = xcalloc(ipcount, sizeof(struct sockaddr_storage));
 	i->addrs.bad_mask = xcalloc(ipcount, sizeof(unsigned char));
 	for (j = 0, k = 0; k < ipcount; k++) {
 	    if (safe_inet_addr(A[k], &i->addrs.in_addrs[j]))
@@ -304,19 +304,23 @@
 }
 #else
 static ipcache_entry *
-ipcacheParse(ipcache_entry * i, rfc1035_rr * answers, int nr, const char *error_message)
+ipcacheParse(ipcache_entry * i, rfc1035_rr * answers, int nrx, const char *error_message)
 {
     int k;
     int j;
     int na = 0;
+    int nr = 0;
     int ttl = 0;
     const char *name = (const char *) i->hash.key;
-    i->expires = squid_curtime + Config.negativeDnsTtl;
-    i->flags.negcached = 1;
-    safe_free(i->addrs.in_addrs);
-    safe_free(i->addrs.bad_mask);
-    safe_free(i->error_message);
-    i->addrs.count = 0;
+
+	debug(14, 3) ("ipcacheParse: ipcache_entry %x\n", i);
+    nr = nrx;
+    if (nrx >= 5000)
+	nr = nrx - 10000;
+    if (!i->addrs.count) {
+	i->expires = squid_curtime + Config.negativeDnsTtl;
+	i->flags.negcached = 1;
+    }
     if (nr < 0) {
 	debug(14, 3) ("ipcacheParse: Lookup failed '%s' for '%s'\n",
 	    error_message, (const char *) i->hash.key);
@@ -324,47 +328,88 @@
 	return i;
     }
     if (nr == 0) {
-	debug(14, 3) ("ipcacheParse: No DNS records in response to '%s'\n", name);
-	i->error_message = xstrdup("No DNS records");
+	if (!i->addrs.count && !nrx) {
+	    debug(14, 3) ("ipcacheParse: No DNS records in response to '%s'\n", name);
+	    i->error_message = xstrdup("No DNS records");
+	}
 	return i;
     }
     assert(answers);
     for (k = 0; k < nr; k++) {
-	if (answers[k].type != RFC1035_TYPE_A)
+	if ((answers[k].type != RFC1035_TYPE_A) && (answers[k].type != RFC1035_TYPE_AAAA))
 	    continue;
 	if (answers[k].class != RFC1035_CLASS_IN)
 	    continue;
-	if (answers[k].rdlength != 4) {
+	if ((answers[k].rdlength != 4) && (answers[k].rdlength != 16)) {
 	    debug(14, 1) ("ipcacheParse: Invalid IP address in response to '%s'\n", name);
 	    continue;
 	}
 	na++;
     }
     if (na == 0) {
-	debug(14, 1) ("ipcacheParse: No Address records in response to '%s'\n", name);
-	i->error_message = xstrdup("No Address records");
+	if (!i->addrs.count && nrx < 10000) {
+	    debug(14, 1) ("ipcacheParse: No Address records in response to '%s'\n", name);
+	    i->error_message = xstrdup("No Address records");
+	}
 	return i;
     }
     i->flags.negcached = 0;
-    i->addrs.in_addrs = xcalloc(na, sizeof(struct in_addr));
-    i->addrs.bad_mask = xcalloc(na, sizeof(unsigned char));
+    if (i->addrs.count > 0) {
+        int total_cnt = i->addrs.count + na;
+	if (total_cnt > 255) total_cnt == 255;
+	i->addrs.in_addrs = xrealloc(i->addrs.in_addrs, total_cnt*sizeof(struct sockaddr_storage));
+	i->addrs.bad_mask = xrealloc(i->addrs.bad_mask, total_cnt*sizeof(unsigned char));
+    }
+    else {
+	i->addrs.in_addrs = xcalloc(na, sizeof(struct sockaddr_storage));
+	i->addrs.bad_mask = xcalloc(na, sizeof(unsigned char));
+    }
     for (j = 0, k = 0; k < nr; k++) {
 	if (answers[k].class != RFC1035_CLASS_IN)
 	    continue;
 	if (answers[k].type == RFC1035_TYPE_A) {
+	    struct sockaddr_in *this_answer = (struct sockaddr_in *)&i->addrs.in_addrs[j+i->addrs.count];
 	    if (answers[k].rdlength != 4)
 		continue;
-	    xmemcpy(&i->addrs.in_addrs[j++], answers[k].rdata, 4);
+	    this_answer->sin_family = AF_INET;
+#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
+	    this_answer->sin_len = sizeof(struct sockaddr_in);
+#endif
+	    xmemcpy(&this_answer->sin_addr, answers[k].rdata, 4);
+	    debug(14, 3) ("ipcacheParse: #%d %s\n",
+		j,
+		sockaddr_ntoa((struct sockaddr *)&i->addrs.in_addrs[j+i->addrs.count]));
+	    j++;
+	} else if (answers[k].type == RFC1035_TYPE_AAAA) {
+	    struct sockaddr_in6 *this_answer = (struct sockaddr_in6 *)&i->addrs.in_addrs[j+i->addrs.count];
+	    if (answers[k].rdlength != 16)
+		continue;
+	    this_answer->sin6_family = AF_INET6;
+#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
+	    this_answer->sin6_len = sizeof(struct sockaddr_in6);
+#endif
+	    xmemcpy(&this_answer->sin6_addr, answers[k].rdata, 16);
+	    i->addrs.bad_mask[j+i->addrs.count] = 0;
+	    i->addrs.count6++;
+	    if (IN6_IS_ADDR_V4MAPPED(&(this_answer->sin6_addr))) {
+		i->addrs.bad_mask[j+i->addrs.count] = TRUE;
+		i->addrs.badcount++;
+		i->addrs.badcount6++;
+	    }
 	    debug(14, 3) ("ipcacheParse: #%d %s\n",
-		j - 1,
-		inet_ntoa(i->addrs.in_addrs[j - 1]));
+		j,
+		sockaddr_ntoa((struct sockaddr *)&i->addrs.in_addrs[j+i->addrs.count]));
+	    j++;
+	    i->addrs.cur = i->addrs.count;
+	    if (i->addrs.cur)
+		i->addrs.cur--;
 	} else if (answers[k].type != RFC1035_TYPE_CNAME)
 	    continue;
 	if (ttl == 0 || ttl > answers[k].ttl)
 	    ttl = answers[k].ttl;
     }
-    if (na < 256)
-	i->addrs.count = (unsigned char) na;
+    if ((i->addrs.count + na) < 256)
+	i->addrs.count += (unsigned char) na;
     else
 	i->addrs.count = 255;
     if (ttl == 0 || ttl > Config.positiveDnsTtl)
@@ -384,10 +429,21 @@
 ipcacheHandleReply(void *data, rfc1035_rr * answers, int na, const char *error_message)
 #endif
 {
+    int pairs = 0;
     generic_cbdata *c = data;
     ipcache_entry *i = c->data;
-    cbdataFree(c);
-    c = NULL;
+
+#if !USE_DNSSERVERS
+    if (na > 5000) {
+	pairs = 1;
+    }
+    if (!pairs) {
+#endif
+	cbdataFree(c);
+	c = NULL;
+#if !USE_DNSSERVERS
+    }
+#endif
     IpcacheStats.replies++;
     statHistCount(&statCounter.dns.svc_time,
 	tvSubMsec(i->request_time, current_time));
@@ -396,8 +452,15 @@
 #else
     ipcacheParse(i, answers, na, error_message);
 #endif
+#if !USE_DNSSERVERS
+    if (!pairs)
+    {
+#endif
     ipcacheAddEntry(i);
     ipcacheCallback(i);
+#if !USE_DNSSERVERS
+    }
+#endif
 }
 
 void
@@ -450,6 +513,7 @@
     i->request_time = current_time;
     c = cbdataAlloc(generic_cbdata);
     c->data = i;
+    debug(14, 5) ("ipcache_nbgethostbyname: create ipcacheEntry %x'\n", (void *)i);
 #if USE_DNSSERVERS
     dnsSubmit(hashKeyStr(&i->hash), ipcacheHandleReply, c);
 #else
@@ -474,7 +538,7 @@
 	debug(14, 1) ("Successful DNS name lookup tests...\n");
     }
     memset(&static_addrs, '\0', sizeof(ipcache_addrs));
-    static_addrs.in_addrs = xcalloc(1, sizeof(struct in_addr));
+    static_addrs.in_addrs = xcalloc(1, sizeof(struct sockaddr_storage));
     static_addrs.bad_mask = xcalloc(1, sizeof(unsigned char));
     ipcache_high = (long) (((float) Config.ipcache.size *
 	    (float) Config.ipcache.high) / (float) 100);
@@ -535,7 +599,7 @@
 	(int) i->addrs.count,
 	(int) i->addrs.badcount);
     for (k = 0; k < (int) i->addrs.count; k++) {
-	storeAppendPrintf(sentry, " %15s-%3s", inet_ntoa(i->addrs.in_addrs[k]),
+	storeAppendPrintf(sentry, " %15s-%3s", sockaddr_ntoa(&i->addrs.in_addrs[k]),
 	    i->addrs.bad_mask[k] ? "BAD" : "OK ");
     }
     storeAppendPrintf(sentry, "\n");
@@ -606,15 +670,17 @@
 ipcache_addrs *
 ipcacheCheckNumeric(const char *name)
 {
-    struct in_addr ip;
+    struct sockaddr_storage ip;
     /* check if it's already a IP address in text form. */
     if (!safe_inet_addr(name, &ip))
 	return NULL;
     static_addrs.count = 1;
+    static_addrs.count6 = ip.ss_family == AF_INET6 ? 1 : 0;
     static_addrs.cur = 0;
-    static_addrs.in_addrs[0].s_addr = ip.s_addr;
+    xmemcpy(&static_addrs.in_addrs[0], &ip, sizeof(ip));
     static_addrs.bad_mask[0] = FALSE;
     static_addrs.badcount = 0;
+    static_addrs.badcount6 = 0;
     return &static_addrs;
 }
 
@@ -652,20 +718,21 @@
     for (k = 0; k < ia->count; k++) {
 	if (++ia->cur == ia->count)
 	    ia->cur = 0;
+	if (ia->badcount6 < ia->count6 && ia->in_addrs[ia->cur].ss_family == AF_INET)
+	    continue;
 	if (!ia->bad_mask[ia->cur])
 	    break;
     }
-    if (k == ia->count) {
+    if (k == ia->count && ia->badcount6 == ia->count6) {
 	/* All bad, reset to All good */
 	debug(14, 3) ("ipcacheCycleAddr: Changing ALL %s addrs from BAD to OK\n",
 	    name);
 	for (k = 0; k < ia->count; k++)
 	    ia->bad_mask[k] = 0;
 	ia->badcount = 0;
+	ia->badcount6 = 0;
 	ia->cur = 0;
     }
-    debug(14, 3) ("ipcacheCycleAddr: %s now at %s\n", name,
-	inet_ntoa(ia->in_addrs[ia->cur]));
 }
 
 /*
@@ -673,7 +740,7 @@
  * advance the current pointer to the next OK address.
  */
 void
-ipcacheMarkBadAddr(const char *name, struct in_addr addr)
+ipcacheMarkBadAddr(const char *name, struct sockaddr *addr)
 {
     ipcache_entry *i;
     ipcache_addrs *ia;
@@ -682,7 +749,17 @@
 	return;
     ia = &i->addrs;
     for (k = 0; k < (int) ia->count; k++) {
-	if (ia->in_addrs[k].s_addr == addr.s_addr)
+	if (ia->in_addrs[k].ss_family != addr->sa_family)
+	    continue;
+	if ((ia->in_addrs[k].ss_family == AF_INET) &&
+	    !memcmp(&((struct sockaddr_in *)&ia->in_addrs[k])->sin_addr,
+		&((struct sockaddr_in *)addr)->sin_addr,
+		sizeof(struct in_addr)) )
+	    break;
+	if ((ia->in_addrs[k].ss_family == AF_INET6) &&
+	    !memcmp(&((struct sockaddr_in6 *)&ia->in_addrs[k])->sin6_addr,
+		&((struct sockaddr_in6 *)addr)->sin6_addr,
+		sizeof(struct in6_addr)) )
 	    break;
     }
     if (k == (int) ia->count)	/* not found */
@@ -690,14 +767,15 @@
     if (!ia->bad_mask[k]) {
 	ia->bad_mask[k] = TRUE;
 	ia->badcount++;
-	i->expires = XMIN(squid_curtime + XMAX(60, Config.negativeDnsTtl), i->expires);
-	debug(14, 2) ("ipcacheMarkBadAddr: %s [%s]\n", name, inet_ntoa(addr));
+	ia->badcount6 += ia->in_addrs[k].ss_family == AF_INET6? 1 : 0;
+	i->expires = XMIN(squid_curtime + XMAX(60, Config.negativeDnsTtl*(ia->count - ia->badcount)), i->expires);
+	debug(14, 2) ("ipcacheMarkBadAddr: %s [%s]\n", name, sockaddr_ntoa(addr));
     }
     ipcacheCycleAddr(name, ia);
 }
 
 void
-ipcacheMarkGoodAddr(const char *name, struct in_addr addr)
+ipcacheMarkGoodAddr(const char *name, struct sockaddr *addr)
 {
     ipcache_entry *i;
     ipcache_addrs *ia;
@@ -706,7 +784,17 @@
 	return;
     ia = &i->addrs;
     for (k = 0; k < (int) ia->count; k++) {
-	if (ia->in_addrs[k].s_addr == addr.s_addr)
+	if (ia->in_addrs[k].ss_family != addr->sa_family)
+	    continue;
+	if ((ia->in_addrs[k].ss_family == AF_INET) &&
+	    !memcmp(&((struct sockaddr_in *)&ia->in_addrs[k])->sin_addr,
+		&((struct sockaddr_in *)addr)->sin_addr,
+		sizeof(struct in_addr)) )
+	    break;
+	if ((ia->in_addrs[k].ss_family == AF_INET6) &&
+	    !memcmp(&((struct sockaddr_in6 *)&ia->in_addrs[k])->sin6_addr,
+		&((struct sockaddr_in6 *)addr)->sin6_addr,
+		sizeof(struct in6_addr)) )
 	    break;
     }
     if (k == (int) ia->count)	/* not found */
@@ -715,7 +803,8 @@
 	return;
     ia->bad_mask[k] = FALSE;
     ia->badcount--;
-    debug(14, 2) ("ipcacheMarkGoodAddr: %s [%s]\n", name, inet_ntoa(addr));
+    ia->badcount6 -= ia->in_addrs[k].ss_family == AF_INET6? 1 : 0;
+    debug(14, 2) ("ipcacheMarkGoodAddr: %s [%s]\n", name, sockaddr_ntoa(addr));
 }
 
 static void
@@ -756,14 +845,18 @@
 ipcacheAddEntryFromHosts(const char *name, const char *ipaddr)
 {
     ipcache_entry *i;
-    struct in_addr ip;
+    struct sockaddr_storage ip;
     if (!safe_inet_addr(ipaddr, &ip)) {
+/*
 	if (strchr(ipaddr, ':') && strspn(ipaddr, "0123456789abcdefABCDEF:") == strlen(ipaddr)) {
 	    debug(14, 3) ("ipcacheAddEntryFromHosts: Skipping IPv6 address '%s'\n", ipaddr);
 	} else {
+*/
 	    debug(14, 1) ("ipcacheAddEntryFromHosts: Bad IP address '%s'\n",
 		ipaddr);
+/*
 	}
+*/
 	return 1;
     }
     if ((i = ipcache_get(name))) {
@@ -779,11 +872,13 @@
     }
     i = ipcacheCreateEntry(name);
     i->addrs.count = 1;
+    i->addrs.count6 = ip.ss_family == AF_INET6 ? 1 : 0 ;
     i->addrs.cur = 0;
     i->addrs.badcount = 0;
-    i->addrs.in_addrs = xcalloc(1, sizeof(struct in_addr));
+    i->addrs.badcount6 = 0;
+    i->addrs.in_addrs = xcalloc(1, sizeof(struct sockaddr_storage));
     i->addrs.bad_mask = xcalloc(1, sizeof(unsigned char));
-    i->addrs.in_addrs[0].s_addr = ip.s_addr;
+    xmemcpy(&i->addrs.in_addrs[0], &ip, sizeof(ip));
     i->addrs.bad_mask[0] = FALSE;
     i->flags.fromhosts = 1;
     ipcacheAddEntry(i);
diff -r -u squid-2.6.STABLE13/src/main.c new-STABLE13/src/main.c
--- squid-2.6.STABLE13/src/main.c	Tue Mar 13 07:25:40 2007
+++ new-STABLE13/src/main.c	Sun May 13 00:59:37 2007
@@ -662,6 +662,7 @@
 {
     int errcount = 0;
     int loop_delay;
+    struct sockaddr_storage curaddr;
 #ifdef _SQUID_WIN32_
     int WIN32_init_err;
 #endif
@@ -694,11 +695,15 @@
 #endif /* HAVE_MALLOPT */
 
     memset(&local_addr, '\0', sizeof(struct in_addr));
-    safe_inet_addr(localhost, &local_addr);
+    memset(&curaddr, '\0', sizeof(curaddr));
+    safe_inet_addr(localhost, &curaddr);
+    local_addr.s_addr = ((struct sockaddr_in *)&curaddr)->sin_addr.s_addr;
     memset(&any_addr, '\0', sizeof(struct in_addr));
-    safe_inet_addr("0.0.0.0", &any_addr);
+    safe_inet_addr("0.0.0.0", &curaddr);
+    any_addr.s_addr = ((struct sockaddr_in *)&curaddr)->sin_addr.s_addr;
     memset(&no_addr, '\0', sizeof(struct in_addr));
-    safe_inet_addr("255.255.255.255", &no_addr);
+    safe_inet_addr("255.255.255.255", &curaddr);
+    no_addr.s_addr = ((struct sockaddr_in *)&curaddr)->sin_addr.s_addr;
     squid_srandom(time(NULL));
 
     getCurrentTime();
diff -r -u squid-2.6.STABLE13/src/multicast.c new-STABLE13/src/multicast.c
--- squid-2.6.STABLE13/src/multicast.c	Fri Jan 12 09:37:19 2001
+++ new-STABLE13/src/multicast.c	Sun May 13 00:59:37 2007
@@ -40,9 +40,18 @@
 {
 #ifdef IP_MULTICAST_TTL
     char ttl = (char) mcast_ttl;
-    if (setsockopt(fd, IPPROTO_IP, IP_MULTICAST_TTL, &ttl, 1) < 0)
-	debug(50, 1) ("comm_set_mcast_ttl: FD %d, TTL: %d: %s\n",
-	    fd, mcast_ttl, xstrerror());
+    struct sockaddr_storage addr;
+    socklen_t addrlen = sizeof(addr);
+    
+    getsockname(fd, (struct sockaddr *)&addr, &addrlen);
+    if (addr.ss_family == AF_INET6)
+	if (setsockopt(fd, IPPROTO_IPV6, IPV6_MULTICAST_HOPS, &ttl, 1) < 0)
+	    debug(50, 1) ("comm_set_mcast_ttl: FD %d, TTL: %d: %s\n",
+		fd, mcast_ttl, xstrerror());
+    if (addr.ss_family == AF_INET)
+	if (setsockopt(fd, IPPROTO_IP, IP_MULTICAST_TTL, &ttl, 1) < 0)
+	    debug(50, 1) ("comm_set_mcast_ttl: FD %d, TTL: %d: %s\n",
+		fd, mcast_ttl, xstrerror());
 #endif
     return 0;
 }
@@ -52,9 +61,12 @@
 {
 #ifdef IP_MULTICAST_TTL
     int fd = theInIcpConnection;
+    int fd6 = theInIcpConnection6;
     struct ip_mreq mr;
+    struct ipv6_mreq mr6;
     int i;
     int x;
+    int mcastTTL = 16;
     char c = 0;
     if (ia == NULL) {
 	debug(7, 0) ("comm_join_mcast_groups: Unknown host\n");
@@ -62,17 +74,34 @@
     }
     for (i = 0; i < (int) ia->count; i++) {
 	debug(7, 10) ("Listening for ICP requests on %s\n",
-	    inet_ntoa(*(ia->in_addrs + i)));
-	mr.imr_multiaddr.s_addr = (ia->in_addrs + i)->s_addr;
-	mr.imr_interface.s_addr = INADDR_ANY;
-	x = setsockopt(fd, IPPROTO_IP, IP_ADD_MEMBERSHIP,
-	    (char *) &mr, sizeof(struct ip_mreq));
-	if (x < 0)
-	    debug(7, 1) ("comm_join_mcast_groups: FD %d, [%s]\n",
-		fd, inet_ntoa(*(ia->in_addrs + i)));
-	x = setsockopt(fd, IPPROTO_IP, IP_MULTICAST_LOOP, &c, 1);
-	if (x < 0)
-	    debug(7, 1) ("Can't disable multicast loopback: %s\n", xstrerror());
+	    sockaddr_ntoa((&ia->in_addrs + i)));
+	if (ia->in_addrs->ss_family == AF_INET6) {
+	    memcpy(&mr6.ipv6mr_multiaddr,
+		&(((struct sockaddr_in6 *)ia->in_addrs)->sin6_addr),
+		sizeof(struct in6_addr));
+	    mr6.ipv6mr_interface = 0;
+	    x = setsockopt(fd6, IPPROTO_IPV6, IPV6_MULTICAST_LOOP, &c, 1);
+	    if (x < 0)
+		debug(7, 1) ("Can't disable multicast loopback: %s\n", xstrerror());
+	    x = setsockopt(fd6, IPPROTO_IPV6, IPV6_JOIN_GROUP, 
+		    &mr6, sizeof(mr6));
+	    if (x < 0)
+		debug(7, 1) ("comm_join_mcast_groups: FD %d, [%s]\n",
+		    fd6, sockaddr_ntoa((ia->in_addrs + i)));
+		
+	}
+	if (ia->in_addrs->ss_family == AF_INET) {
+	    mr.imr_multiaddr.s_addr = ((struct sockaddr_in *)(ia->in_addrs + i))->sin_addr.s_addr;
+	    mr.imr_interface.s_addr = INADDR_ANY;
+	    x = setsockopt(fd, IPPROTO_IP, IP_ADD_MEMBERSHIP,
+		(char *) &mr, sizeof(struct ip_mreq));
+	    if (x < 0)
+		debug(7, 1) ("comm_join_mcast_groups: FD %d, [%s]\n",
+		    fd, sockaddr_ntoa((ia->in_addrs + i)));
+	    x = setsockopt(fd, IPPROTO_IP, IP_MULTICAST_LOOP, &c, 1);
+	    if (x < 0)
+		debug(7, 1) ("Can't disable multicast loopback: %s\n", xstrerror());
+	}
     }
 #endif
 }
